
<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>imapclient.response_types &#8212; IMAPClient 2.3.1 documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../../_static/sphinxdoc.css" />
    <script data-url_root="../../" id="documentation_options" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/_sphinx_javascript_frameworks_compat.js"></script>
    <script src="../../_static/doctools.js"></script>
    <link rel="search" title="Search" href="../../search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a></li>
        <li class="nav-item nav-item-0"><a href="../../index.html">IMAPClient 2.3.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../index.html" accesskey="U">Module code</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">imapclient.response_types</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for imapclient.response_types</h1><div class="highlight"><pre>
<span></span><span class="c1"># Copyright (c) 2014, Menno Smits</span>
<span class="c1"># Released subject to the New BSD License</span>
<span class="c1"># Please see http://en.wikipedia.org/wiki/BSD_licenses</span>

<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">unicode_literals</span>

<span class="kn">from</span> <span class="nn">collections</span> <span class="kn">import</span> <span class="n">namedtuple</span>
<span class="kn">from</span> <span class="nn">email.utils</span> <span class="kn">import</span> <span class="n">formataddr</span>

<span class="kn">import</span> <span class="nn">six</span>

<span class="kn">from</span> <span class="nn">.util</span> <span class="kn">import</span> <span class="n">to_unicode</span>


<div class="viewcode-block" id="Envelope"><a class="viewcode-back" href="../../api.html#imapclient.response_types.Envelope">[docs]</a><span class="k">class</span> <span class="nc">Envelope</span><span class="p">(</span>
    <span class="n">namedtuple</span><span class="p">(</span>
        <span class="s2">&quot;Envelope&quot;</span><span class="p">,</span>
        <span class="s2">&quot;date subject from_ sender reply_to to &quot;</span> <span class="o">+</span> <span class="s2">&quot;cc bcc in_reply_to message_id&quot;</span><span class="p">,</span>
    <span class="p">)</span>
<span class="p">):</span>
    <span class="sa">r</span><span class="sd">&quot;&quot;&quot;Represents envelope structures of messages. Returned when parsing</span>
<span class="sd">    ENVELOPE responses.</span>

<span class="sd">    :ivar date: A datetime instance that represents the &quot;Date&quot; header.</span>
<span class="sd">    :ivar subject: A string that contains the &quot;Subject&quot; header.</span>
<span class="sd">    :ivar from\_: A tuple of Address objects that represent one or more</span>
<span class="sd">      addresses from the &quot;From&quot; header, or None if header does not exist.</span>
<span class="sd">    :ivar sender: As for from\_ but represents the &quot;Sender&quot; header.</span>
<span class="sd">    :ivar reply_to: As for from\_ but represents the &quot;Reply-To&quot; header.</span>
<span class="sd">    :ivar to: As for from\_ but represents the &quot;To&quot; header.</span>
<span class="sd">    :ivar cc: As for from\_ but represents the &quot;Cc&quot; header.</span>
<span class="sd">    :ivar bcc: As for from\_ but represents the &quot;Bcc&quot; recipients.</span>
<span class="sd">    :ivar in_reply_to: A string that contains the &quot;In-Reply-To&quot; header.</span>
<span class="sd">    :ivar message_id: A string that contains the &quot;Message-Id&quot; header.</span>

<span class="sd">    A particular issue to watch out for is IMAP&#39;s handling of &quot;group</span>
<span class="sd">    syntax&quot; in address fields. This is often encountered as a</span>
<span class="sd">    recipient header of the form::</span>

<span class="sd">        undisclosed-recipients:;</span>

<span class="sd">    but can also be expressed per this more general example::</span>

<span class="sd">        A group: a@example.com, B &lt;b@example.org&gt;;</span>

<span class="sd">    This example would yield the following Address tuples::</span>

<span class="sd">      Address(name=None, route=None, mailbox=u&#39;A group&#39;, host=None)</span>
<span class="sd">      Address(name=None, route=None, mailbox=u&#39;a&#39;, host=u&#39;example.com&#39;)</span>
<span class="sd">      Address(name=u&#39;B&#39;, route=None, mailbox=u&#39;b&#39;, host=u&#39;example.org&#39;)</span>
<span class="sd">      Address(name=None, route=None, mailbox=None, host=None)</span>

<span class="sd">    The first Address, where ``host`` is ``None``, indicates the start</span>
<span class="sd">    of the group. The ``mailbox`` field contains the group name. The</span>
<span class="sd">    final Address, where both ``mailbox`` and ``host`` are ``None``,</span>
<span class="sd">    indicates the end of the group.</span>

<span class="sd">    See :rfc:`3501#section-7.4.2` and :rfc:`2822` for further details.</span>

<span class="sd">    &quot;&quot;&quot;</span></div>


<div class="viewcode-block" id="Address"><a class="viewcode-back" href="../../api.html#imapclient.response_types.Address">[docs]</a><span class="k">class</span> <span class="nc">Address</span><span class="p">(</span><span class="n">namedtuple</span><span class="p">(</span><span class="s2">&quot;Address&quot;</span><span class="p">,</span> <span class="s2">&quot;name route mailbox host&quot;</span><span class="p">)):</span>
    <span class="sd">&quot;&quot;&quot;Represents electronic mail addresses. Used to store addresses in</span>
<span class="sd">    :py:class:`Envelope`.</span>

<span class="sd">    :ivar name: The address &quot;personal name&quot;.</span>
<span class="sd">    :ivar route: SMTP source route (rarely used).</span>
<span class="sd">    :ivar mailbox: Mailbox name (what comes just before the @ sign).</span>
<span class="sd">    :ivar host: The host/domain name.</span>

<span class="sd">    As an example, an address header that looks like::</span>

<span class="sd">        Mary Smith &lt;mary@foo.com&gt;</span>

<span class="sd">    would be represented as::</span>

<span class="sd">        Address(name=u&#39;Mary Smith&#39;, route=None, mailbox=u&#39;mary&#39;, host=u&#39;foo.com&#39;)</span>

<span class="sd">    See :rfc:`2822` for more detail.</span>

<span class="sd">    See also :py:class:`Envelope` for information about handling of</span>
<span class="sd">    &quot;group syntax&quot;.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="fm">__str__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">mailbox</span> <span class="ow">and</span> <span class="bp">self</span><span class="o">.</span><span class="n">host</span><span class="p">:</span>
            <span class="n">address</span> <span class="o">=</span> <span class="n">to_unicode</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">mailbox</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;@&quot;</span> <span class="o">+</span> <span class="n">to_unicode</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">host</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">address</span> <span class="o">=</span> <span class="n">to_unicode</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">mailbox</span> <span class="ow">or</span> <span class="bp">self</span><span class="o">.</span><span class="n">host</span><span class="p">)</span>

        <span class="k">return</span> <span class="n">formataddr</span><span class="p">((</span><span class="n">to_unicode</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="p">),</span> <span class="n">address</span><span class="p">))</span></div>


<div class="viewcode-block" id="SearchIds"><a class="viewcode-back" href="../../api.html#imapclient.response_types.SearchIds">[docs]</a><span class="k">class</span> <span class="nc">SearchIds</span><span class="p">(</span><span class="nb">list</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Contains a list of message ids as returned by IMAPClient.search().</span>

<span class="sd">    The *modseq* attribute will contain the MODSEQ value returned by</span>
<span class="sd">    the server (only if the SEARCH command sent involved the MODSEQ</span>
<span class="sd">    criteria). See :rfc:`4551` for more details.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">):</span>
        <span class="nb">list</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">*</span><span class="n">args</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">modseq</span> <span class="o">=</span> <span class="kc">None</span></div>


<div class="viewcode-block" id="BodyData"><a class="viewcode-back" href="../../api.html#imapclient.response_types.BodyData">[docs]</a><span class="k">class</span> <span class="nc">BodyData</span><span class="p">(</span><span class="nb">tuple</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Returned when parsing BODY and BODYSTRUCTURE responses.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="nd">@classmethod</span>
    <span class="k">def</span> <span class="nf">create</span><span class="p">(</span><span class="bp">cls</span><span class="p">,</span> <span class="n">response</span><span class="p">):</span>
        <span class="c1"># In case of multipart messages we will see at least 2 tuples</span>
        <span class="c1"># at the start. Nest these in to a list so that the returned</span>
        <span class="c1"># response tuple always has a consistent number of elements</span>
        <span class="c1"># regardless of whether the message is multipart or not.</span>
        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">response</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="nb">tuple</span><span class="p">):</span>
            <span class="c1"># Multipart, find where the message part tuples stop</span>
            <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">part</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">response</span><span class="p">):</span>
                <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">part</span><span class="p">,</span> <span class="n">six</span><span class="o">.</span><span class="n">binary_type</span><span class="p">):</span>
                    <span class="k">break</span>
            <span class="k">return</span> <span class="bp">cls</span><span class="p">(([</span><span class="bp">cls</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="n">part</span><span class="p">)</span> <span class="k">for</span> <span class="n">part</span> <span class="ow">in</span> <span class="n">response</span><span class="p">[:</span><span class="n">i</span><span class="p">]],)</span> <span class="o">+</span> <span class="n">response</span><span class="p">[</span><span class="n">i</span><span class="p">:])</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="bp">cls</span><span class="p">(</span><span class="n">response</span><span class="p">)</span>

    <span class="nd">@property</span>
    <span class="k">def</span> <span class="nf">is_multipart</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="nb">isinstance</span><span class="p">(</span><span class="bp">self</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="nb">list</span><span class="p">)</span></div>
</pre></div>

            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../py-modindex.html" title="Python Module Index"
             >modules</a></li>
        <li class="nav-item nav-item-0"><a href="../../index.html">IMAPClient 2.3.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../index.html" >Module code</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">imapclient.response_types</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2014, Menno Smits.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 5.0.2.
    </div>
  </body>
</html>